"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CM = require("../typescript-node-client/api");
var MessageApiClient = /** @class */ (function () {
    function MessageApiClient(productToken) {
        this.productToken = productToken;
    }
    MessageApiClient.prototype.SendTextMessage = function (to, from, message) {
        var api = new CM.MessagesApi();
        var messageEnvelope = new CM.MessageEnvelope();
        messageEnvelope.messages = new CM.Messages();
        messageEnvelope.messages.authentication = new CM.Authentication();
        messageEnvelope.messages.authentication.productToken = this.productToken;
        var msg = new CM.Message();
        msg.from = from;
        msg.body = new CM.MessageBody();
        msg.body.type = "AUTO";
        msg.body.content = message;
        var recipient = {
            number: to
        };
        msg.to = [recipient];
        messageEnvelope.messages.msg = new Array();
        messageEnvelope.messages.msg.push(msg);
        // Send the message
        var result = api.messagesSendMessage(messageEnvelope);
        // Return the promise.
        return result;
    };
    return MessageApiClient;
}());
exports.MessageApiClient = MessageApiClient;
//# sourceMappingURL=MessageApiClient.js.map