/// <reference types="node" />
/**
 * Bulk SMS API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import localVarRequest = require('request');
import http = require('http');
import Promise = require('bluebird');
/**
* Authentication
*/
export declare class Authentication {
    /**
    * Required: This is the product token for authentication. Visit https://gateway.cmtelecom.com to retrieve your product token.   Example: 00000000-0000-0000-0000-000000000000'
    */
    'productToken': string;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* The message
*/
export declare class Message {
    /**
    * Required. This is the sender name. The maximum length is 11 alphanumerical characters or 16 digits. Example: 'CM Telecom'
    */
    'from': string;
    /**
    * Required. This contains the message text.
    */
    'body': MessageBody;
    /**
    * To send messages longer than 160 characters you need to send them as multipart message (also called concatenated messages). We will cut the message into more smaller messages and the phone will paste them together again. You will need to add a minimum and maximum of message parts using this parameter and {CM.Sms.Server.HttpMTGatewayDocsWebsite.Models.Message.MaximumNumberOfMessageParts}
    */
    'minimumNumberOfMessageParts': number;
    /**
    * To send messages longer than 160 characters you need to send them as multipart message (also called concatenated messages). We will cut the message into more smaller messages and the phone will paste them together again. You will need to add a minimum and maximum of message parts using this parameter and {CM.Sms.Server.HttpMTGatewayDocsWebsite.Models.Message.MinimumNumberOfMessageParts}
    */
    'maximumNumberOfMessageParts': number;
    /**
    * Here you can include your message reference. This information will be returned in a status report so you can match the message and it's status. Restrictions: 1 - 32 alphanumeric characters.
    */
    'reference': string;
    /**
    * Required. This is the destination mobile number.   Restrictions: this value should be in international format. A single mobile number per request. Example: '00447911123456'
    */
    'to': Array<Recipient>;
    /**
    * The custom grouping field is an optional field that can be used to tag messages. These tags will be used by other CM products, like the Transactions API. Despite not being immediately visible to you yet, custom groupings can already be assigned.  Applying custom grouping names to messages helps filter your messages.With up to three levels of custom grouping fields that can be set, subsets of messages can be further broken down. The custom grouping name can be up to 100 characters of your choosing.  It’s recommended to limit the number of unique custom groupings to 1000. Please contact support in case you would like to exceed this number.
    */
    'customGrouping': string;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* Contains the body of the message.
*/
export declare class MessageBody {
    /**
    * Required. This is the message text.   For GSM7-encoded messages 1 message can contain up to 160 characters, for multipart messages, 1 message can contain up to 153 characters (the other bytes are used to define the multipart messages)    For Unicode-encoded messages 1 message can contain up to 70 characters, for multipart messages, 1 message can contain up to 66 characters per message    Unicode messages are sent using UTF-16, so they usually will be 2 bytes long (and certain characters will be send as multiple characters, but I hope we don’t need to discuss that here).     In theory a message can contain 255 message parts, so in theory the maximum length is 39.015. In practice we advise to limit the amount of parts to 8, so either 1224 or 528 characters
    */
    'content': string;
    /**
    * It possible to let our gateway do the encoding detection for you, by setting the type to \"AUTO\"  In case it detects characters that are not part of the GSM character set, the message will be delivered as Unicode.   Any existing DCS value will be ignored.   If the message contains more than 70 characters in Unicode format it will be split into a multipart message.   You can limit the number of parts by setting the maximum number of message parts (see also the section on Multipart below).
    */
    'type': string;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* Envelope containing messages and authentication
*/
export declare class MessageEnvelope {
    'messages': Messages;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* Response for an individual message
*/
export declare class MessageResponse {
    /**
    * Maps to the 'to' of the request
    */
    'to': string;
    /**
    * The status of the message, usually either \"Accepted\" or \"Rejected\"
    */
    'status': string;
    /**
    * Optional: If a reference was supplied in the request, it is returned here.
    */
    'reference': string;
    /**
    * The number of message parts that are sent
    */
    'parts': number;
    /**
    * Optional: Human readable details about this message.
    */
    'messageDetails': string;
    /**
    * The error code, see https://docs.cmtelecom.com/bulk-sms/v1.0#send_a_message|responses_&amp;_errors for more details.
    */
    'messageErrorCode': number;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* The message(s) to send
*/
export declare class Messages {
    /**
    * Required: This contains the product token for authentication.
    */
    'authentication': Authentication;
    /**
    * Required. The msg-object signals a message and should comprise of at least a from, to and body-tag. One HTTP-call can support up to 1000 msg objects.
    */
    'msg': Array<Message>;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* Response from a Message POST
*/
export declare class MessagesResponse {
    /**
    * Human readable text such as: Created 1 message(s)
    */
    'details': string;
    /**
    * The error code, see https://docs.cmtelecom.com/bulk-sms/v1.0#send_a_message|responses_&amp;_errors for more details.
    */
    'errorCode': number;
    /**
    * Detailed information per message
    */
    'messages': Array<MessageResponse>;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
/**
* Contains the  mobile number in international format.
*/
export declare class Recipient {
    /**
    * Required. This is the destination mobile number.   Restrictions: this value should be in international format. A single mobile number per request. Example: '00447911123456'
    */
    'number': string;
    static discriminator: any;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export interface Authentication {
    /**
    * Apply authentication settings to header and query params.
    */
    applyToRequest(requestOptions: localVarRequest.Options): void;
}
export declare class HttpBasicAuth implements Authentication {
    username: string;
    password: string;
    applyToRequest(requestOptions: localVarRequest.Options): void;
    productToken: string;
}
export declare class ApiKeyAuth implements Authentication {
    private location;
    private paramName;
    apiKey: string;
    constructor(location: string, paramName: string);
    applyToRequest(requestOptions: localVarRequest.Options): void;
    productToken: string;
}
export declare class OAuth implements Authentication {
    accessToken: string;
    applyToRequest(requestOptions: localVarRequest.Options): void;
    productToken: string;
}
export declare class VoidAuth implements Authentication {
    username: string;
    password: string;
    applyToRequest(_: localVarRequest.Options): void;
    productToken: string;
}
export declare enum MessagesApiApiKeys {
}
export declare class MessagesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: MessagesApiApiKeys, value: string): void;
    /**
     *
     * @summary CM's Bulk SMS Gateway enables you to send text messages to mobile phones all around the world in very high volume.                            The Bulk SMS Gateway API covers the interface between your application and the CM Platform by means of the HTTP protocol. Only bulk (free of charge for the end user) text messages are supported.
     * @param message
     */
    messagesSendMessage(message: MessageEnvelope): Promise<{
        response: http.ClientResponse;
        body: MessagesResponse;
    }>;
}
